﻿//BackupSaver.jsx by Henryk Jursz, HenJ, http://www.jursz.com, december 2005 - february 2006, january - february 2007, june 2007, november 2009, may 2017
//An InDesign CS-CS6, CC-CC2014 JavaScript for documents backup saving

$.locale = "en";

//all script messages
BS_Script	= "BackupSaver 1.5, \u00a92005-2017 Henryk Jursz";
BS_noPrefs	= "I can't save my settings!\nI'm sorry!";
BS_noLoad	= "I can't load my settings, so I use default settings.";
BS_noFolder	= "Please choose your backup folder.";
BS_Error	= "I can't save backup!\nError: ";
BS_StdPath	= " will be used as default backup folder.";
BS_CopyQnt1	= "Please write quantity";
BS_CopyQnt2	= "of backups (2-999)";
BS_NoBackUp	= "Document not saved\nor opened in read only mode.\nBackup saving is impossible!";
BS_MaxPath	= "\n\nBackups file path is too long (max 259 chars):\n";
BS_MaxName	= "\n\nFile name is too long (max 65 chars):\n";
BS_AccessPr	= "\nPossible you haven't access privileges for saving in backup folder.\nContact with your system administrator.";
BS_SmFiles	= "Save smaller files";

//preferences variables - default settings
var myBS_MaxFile = 20;
var myBS_TmpFolder = "";
var myBS_SmFiles = true;

//is InDesign?
if ((app.name != "Adobe InDesign") || ((app.name == "Adobe InDesign") && (app.documents.length == 0))) {}
else if (app.documents.length != 0) {
	var myBS_AppVersion = parseFloat(app.version);
	(myBS_AppVersion < 4) ? (app.userInteractionLevel = UserInteractionLevels.interactWithAll) : (app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll);

	//save document
	try {
		app.documents[0].save();
		}
	catch (myBS_Error) {
		alert(BS_NoBackUp);
		exit();
		}
	if (File(app.documents[0].fullName).readonly) {
		alert(BS_NoBackUp);
		exit();
		}

	//load saved settings from preference file
	if (!BS_PrefsFileOpen()) {
		//if prefs file don't exit, then user choose tempfolder
		var myBS_Dialog = app.dialogs.add({name: BS_Script, canCancel: true});
		with (myBS_Dialog) {
			with (dialogColumns.add()) {
				with (borderPanels.add()) {
					with (dialogColumns.add()) {
						with (dialogRows.add()) {
							staticTexts.add({staticLabel: BS_CopyQnt1});
							}
						with (dialogRows.add()) {
							staticTexts.add({staticLabel: BS_CopyQnt2});
							myBS_MaxFile_EditField = integerEditboxes.add({editValue: myBS_MaxFile, minWidth: 35});
							}
						myBS_SmFiles = checkboxControls.add({staticLabel: BS_SmFiles, checkedState: myBS_SmFiles});
						}
					}
				}
			}
		if (myBS_Dialog.show() == true) {
			myBS_MaxFile = myBS_MaxFile_EditField.editValue;
			myBS_SmFiles  = myBS_SmFiles.checkedState;
			myBS_Dialog.destroy();
			}
		else {
			myBS_Dialog.destroy();
			myBS_MaxFile = 200;
			myBS_SmFiles = true;
			}
		(myBS_MaxFile == 0) ? (myBS_MaxFile = 20) : {};
		(myBS_MaxFile > 999) ? (myBS_MaxFile = 999) : {};
		(myBS_MaxFile < 2) ? (myBS_MaxFile = 2) : {};
		myBS_TmpFolder = Folder.selectDialog([BS_Script + ". " + BS_noFolder]);
		if ((myBS_TmpFolder != null) && (myBS_TmpFolder != "")) {
			myBS_TmpFolder = myBS_TmpFolder + "/";
			}
		else {
			myBS_TmpFolder = "";
			alert(Folder(app.documents[0].filePath).fsName + "/" + BS_StdPath);
			}
		BS_PrefsFileSave();
		}

	if ((app.documents[0].saved == true) && (!File(app.documents[0].fullName).readonly)) {
		//get document name and folder
		var myBS_DocFolderAndName = File(app.documents[0].fullName + "");
		var myBS_DocFolder = app.documents[0].filePath + "/";
		var myBS_DocName = app.documents[0].name;

		//check extension
		var myBS_DocXtension = "";
		var myBS_DocCounter = myBS_DocName.indexOf(".indd", 0);
		if (myBS_DocCounter != -1) {
			myBS_DocXtension = myBS_DocName.substring(myBS_DocCounter, myBS_DocName.length);
			myBS_DocName = myBS_DocName.substring(0, myBS_DocCounter);
			}
		else {
			myBS_DocCounter = myBS_DocName.indexOf(".indt", 0);
			if (myBS_DocCounter != -1) {
				myBS_DocXtension = myBS_DocName.substring(myBS_DocCounter, myBS_DocName.length);
				myBS_DocName = myBS_DocName.substring(0, myBS_DocCounter);
				}
			}

		(myBS_TmpFolder == "") ? (myBS_TmpFolder = myBS_DocFolder + "Backup_Of_" + myBS_DocName + "/") : (myBS_TmpFolder = myBS_TmpFolder + "Backup_Of_" + myBS_DocName + "/");

		var myBS_TmpFoldX = myBS_TmpFolder;
		if (!Folder(myBS_TmpFoldX).exists) {
			(!Folder(myBS_TmpFoldX).create()) ? (myBS_TmpFoldX = myBS_TmpFolder) : {};
			}
		myBS_TmpFolder = myBS_TmpFoldX;

		//is template or document?
		var myBS_Template = false;
		(myBS_DocXtension == ".indt") ? (myBS_Template = true) : {};

		//determinate backup number
		var myBS_DocCounter = parseInt(app.documents[0].extractLabel("BS_number"));
		(app.documents[0].extractLabel("BS_number") == "") ? (myBS_DocCounter = -1) : {};
		(myBS_DocCounter > myBS_MaxFile-1) ? (myBS_DocCounter = -1) : {};
		(myBS_DocCounter < myBS_MaxFile) ? (myBS_DocCounter = myBS_DocCounter + 1) : {};

		//backup saving     
		var myBS_DocCountTxt = BS_CounterToText(myBS_DocCounter);
		var myBS_DocTempFile = File(myBS_TmpFolder + myBS_DocName + "_" + myBS_DocCountTxt + myBS_DocXtension);
		myBS_DocFolderAndName = File(myBS_DocFolderAndName);
		myBS_DocTempFile = File(File.decode(myBS_DocTempFile));
		//remove old backup file
		if (File(myBS_DocTempFile).exists) {
			File(myBS_DocTempFile).remove();
			}
		if (myBS_SmFiles) {
			try {
				app.documents[0].save(myBS_DocTempFile, myBS_Template);
				}
			catch (myBS_Error) {
				alert(BS_Error + myBS_DocFolderAndName.error);
				}
			}
		else {
			try {
				myBS_DocFolderAndName.copy(File.decode(myBS_DocTempFile));
				}
			catch (myBS_Error) {
				alert(BS_Error + myBS_DocFolderAndName.error);
				}
			}
		//is backup file saved?
		if (!File(myBS_DocTempFile).exists) {
			var myBS_ErrorString = BS_Error + myBS_DocFolderAndName.error;
			BS_MaxName += (File.decode(myBS_DocName) + myBS_DocXtension);
			BS_MaxPath += File.decode(myBS_TmpFolder);
			if (((File.decode(myBS_DocName)).length > 65) || ((File.decode(myBS_DocTempFile)).length > 259)) {
				((File.decode(myBS_DocName)).length > 65) ? (myBS_ErrorString += BS_MaxName) : {};
				((File.decode(myBS_DocTempFile)).length > 259) ? (myBS_ErrorString += BS_MaxPath) : {};
				}
			else myBS_ErrorString += BS_AccessPr;
			alert(myBS_ErrorString);
			}
		else app.documents[0].insertLabel("BS_number", myBS_DocCounter + "");
		myBS_DocFolderAndName = File(File.decode(myBS_DocFolderAndName));
		(myBS_SmFiles) ? (app.documents[0].save(myBS_DocFolderAndName, myBS_Template)) : (app.documents[0].save());
		}
	}//end char, don't touch!

//additional function
//convert digit to text
function BS_CounterToText(myBS_Digit) {
	var myBS_CTT = myBS_Digit + "";
	(myBS_Digit < 10) ? (myBS_CTT = "0" + myBS_CTT) : {};
	(myBS_Digit < 100) ? (myBS_CTT = "0" + myBS_CTT) : {};
	(myBS_Digit < 1000) ? (myBS_CTT = "0" + myBS_CTT) : {};
	return (myBS_CTT);
	}

//open preference file function
function BS_PrefsFileOpen() {
	var myBS_PrFileArray = new Array();
	var myBS_PFO = false;
	var myBS_ScriptFile = File(app.activeScript);
	var myBS_Folder = myBS_ScriptFile.parent;
	var myBS_PrefsFileName = myBS_Folder + "/" + "BackupSaver_prefs.txt";
	var myBS_PrefsFile = File(myBS_PrefsFileName);
	var myOpenedFile = myBS_PrefsFile.open("r", undefined, undefined);
	if (myOpenedFile == true) {
		var myBS_FindLine = myBS_PrefsFile.read();
		myBS_PrFileArray = myBS_FindLine.split("\n");
		}
	myBS_PrefsFile.close();
	if (myBS_PrFileArray.length == 4) {
		myBS_TmpFolder = (myBS_PrFileArray[0] + "");
		myBS_MaxFile = +(myBS_PrFileArray[1] + "");
		myBS_SmFiles = !!(+(myBS_PrFileArray[2] + ""));
		myBS_PFO = true;
		}
	else alert(BS_noLoad);
	return (myBS_PFO);
	}

//save preference file function
function BS_PrefsFileSave() {
	var myBS_PFS = false;
	var myBS_ScriptFile = File(app.activeScript);
	var myBS_Folder = myBS_ScriptFile.parent;
	var myBS_PrefsFileName = myBS_Folder + "/" + "BackupSaver_prefs.txt";
	var myBS_PrefsFile = File(myBS_PrefsFileName);
	var myOpenedFile = myBS_PrefsFile.open("w", undefined, undefined);
	if (myOpenedFile == true) {
		myBS_PrefsFile.writeln(myBS_TmpFolder);
		myBS_PrefsFile.writeln(myBS_MaxFile);
		myBS_PrefsFile.writeln(+myBS_SmFiles);
		myBS_PFS = true;
		}
	else alert(BS_noPrefs);
	myBS_PrefsFile.close();
	return (myBS_PFS);
	}

//end of BackupSaver script (by Henryk Jursz, HenJ 2005-2017)